# Users

Users are a fundamental concept in modern operating systems.

It is useful to be able to create them, both for operators and for services.

| Recipe | Needs | Provides |
| -----: | ----- | -------- |
| [`os-user`](#os-user) | | `os-user` |


## `os-user`

Creates a user.

**Note:** probably must be run as the `root` user.

**Provides**: `os-user(?)` where `?` is the argument `name`.

| Argument | Accepted Values | Default | Description |
| -------: | --------------- | ------- | ----------- |
| name | any username string | *required* | Username of the OS (e.g. Linux) user that already exists. |
| make_group | true, false | true | True if the user should have its own group with the same name. |
| make_home | true, false | true | True if the user's home directory should be created. |
| home | any path string | *optional* | Directory for the user's home. If not specified, the operating system will choose it. |
| password | any string | *optional* | Password for the user. If not specified, no password will be created. |

### Example

Idiomatic example, showing running the recipe as a root user and declaring the provision of the user's home directory.

```scoml
[[os-user]]
@provides directory(/home/hedgedoc)
@user = root
name = hedgedoc
```
