# Installing scone to a server and creating a sous chef

These instructions are provided for Debian-like servers.

## Create a user for your sous

Log in as root on the server you want to control with scone.
Create a user for scone.
```
# adduser --disabled-password scone
```

<!--- on PinePhone (alpine), I needed to do `passwd -d scone` so that ssh would allow connection, since it starts locked but passwd -d deletes the password -->

Make your scone user have passwordless sudo capability.
```
# echo 'scone ALL=(ALL) NOPASSWD: ALL' > /etc/sudoers.d/scone
# chmod 0440 /etc/sudoers.d/scone
# visudo -c # check sudoers file
```

## Install scone on your sous

You'll need the SSH public key for your controlling computer here;
try looking in `/home/$USER/.ssh/id_ed25519.pub` or `/home/$USER/.ssh/id_rsa.pub`.

Alternatively, I suggest generating a new SSH key in your password manager, such as
KeePassXC, and adding it to your SSH agent as-and-when you need to use Scone.

```
# su scone
$ cd
$ mkdir .ssh
$ echo 'ssh-ed25519 AA...bJ user@headmachine' >> .ssh/authorized_keys # use your own SSH public key here
$ chmod -R go-rw .ssh
```

Now activate your Scone virtual environment on your host and run, from within
the `scone` repository directory on your host:
```
./contrib/install_scone.sh scone@machine.example.org
```

## Add to your head configuration

Finally, add a section to your `scone.head.toml` file to describe the new installation
you have made.

```toml
[sous.machine]
host = "machine.example.org"
user = "scone"
souscmd = "/home/scone/.scone/venv/bin/python -m scone.sous ~/.scone"
```

TODO: `scone.sous.toml`, `[groups]`, ...
